/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : April, 1997                                                    */
/* File Name : JSSPSolution.h                                            */
/*************************************************************************/
/*************************************************************************/

#ifndef _JSSPSolution_h
#define _JSSPSolution_h

#include "JSSProblem.h"
#include "FacilitySchedule.h"
#include "Operation.h"

class JSSPSolution
{  protected :
     JSSProblem *myProblem;
     FacilitySchedule  *FacilityScheduleList;
     int FacilityIndex;
     int debug;
     char valid;
     int  cost;

   public :
     ~JSSPSolution();
     JSSPSolution();
     JSSPSolution(const JSSPSolution&);
     JSSPSolution(JSSProblem& Problem);
     JSSProblem * getMyProblem();
     FacilitySchedule * getFacilityScheduleIndex(int); 
     void addFacilitySchedule(FacilitySchedule );
     void solve();
     void solveRandom();
     void restore();
     void LocalImprove();
     void print();
     void setProblem(JSSProblem&);
     void setOnlyMyProblem(JSSProblem&);
     getMaxFacilityNumber();
     getMakespan();
     isFeasible();
     isSchedulable(FacilitySchedule*,Operation*,int *);
     JSSPSolution operator =(const JSSPSolution &Sol);
     operator ==(const JSSPSolution &Sol);
     friend ostream& operator<<(ostream &os, const JSSPSolution &Sol);
     void addOperationToMachineIdnx(int, Operation);

     getNumOfJobs();
     getNumOfFacs();
     void swapJobsOnMachine(int,int,int);
     void swapJobsOrderOnMachine(int,int,int);

     void debugOn();
     void debugOff();
};// end of class JSSPSolution
#endif
